"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_2 = require("@testing-library/react");
var ContainedMathbox_1 = __importDefault(require("./ContainedMathbox"));
var Mathbox_1 = __importDefault(require("./Mathbox"));
var components_1 = require("./components");
function assertNotNil(value) {
    if (value === undefined) {
        throw new Error("Unexpected undefined value");
    }
    if (value === null) {
        throw new Error("Unexpected null value");
    }
}
/**
 * Assert that two mathbox selections have the same nodes in the same order.
 */
var assertSelectionsEqual = function (s1, s2) {
    expect(s1.length).toBe(s2.length);
    Array(s1.length)
        .fill(null)
        .forEach(function (_, i) {
        expect(s1[i]).toBe(s2[i]);
    });
};
describe("ContainedMathbox", function () {
    it("makes a new mathbox instance only if the options have changed", function () {
        var mbRef = { current: null };
        var rerender = (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { options: {}, ref: mbRef })).rerender;
        var mb0 = mbRef.current;
        assertNotNil(mb0);
        rerender(react_1.default.createElement(ContainedMathbox_1.default, { options: {}, ref: mbRef }));
        var mb1 = mbRef.current;
        expect(mb1).toBe(mb0);
        assertNotNil(mb1);
        rerender(react_1.default.createElement(ContainedMathbox_1.default, { options: { plugins: ["core"] }, ref: mbRef }));
        var mb2 = mbRef.current;
        assertNotNil(mb2);
        expect(mb2).not.toBe(mb1);
    });
});
describe("Cartesian", function () {
    it("exposes Mathbox instance via ref", function () {
        var _a, _b;
        var mbRef = { current: null };
        var cartesianRef = { current: null };
        (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
            react_1.default.createElement(components_1.Cartesian, { ref: cartesianRef })));
        expect((_a = mbRef.current) === null || _a === void 0 ? void 0 : _a[0].type).toBe("root");
        expect((_b = cartesianRef.current) === null || _b === void 0 ? void 0 : _b[0].type).toBe("cartesian");
    });
    it("creates a cartesian instance as child of root", function () {
        var _a;
        var mbRef = { current: null };
        (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
            react_1.default.createElement(components_1.Cartesian, null)));
        expect((_a = mbRef.current) === null || _a === void 0 ? void 0 : _a.select("cartesian").length).toBe(1);
    });
    it("creates mathbox children as children of itself", function () {
        var _a, _b, _c;
        var mbRef = { current: null };
        (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
            react_1.default.createElement(components_1.Cartesian, null,
                react_1.default.createElement(components_1.Grid, null),
                react_1.default.createElement(components_1.Grid, null))));
        (_a = mbRef.current) === null || _a === void 0 ? void 0 : _a.print();
        expect((_b = mbRef.current) === null || _b === void 0 ? void 0 : _b.select("cartesian").length).toBe(1);
        expect((_c = mbRef.current) === null || _c === void 0 ? void 0 : _c.select("cartesian grid").length).toBe(2);
    });
    it("removes its mathbox instance when unmounted", function () {
        var _a, _b;
        var mbRef = { current: null };
        var rerender = (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
            react_1.default.createElement(components_1.Cartesian, null))).rerender;
        expect((_a = mbRef.current) === null || _a === void 0 ? void 0 : _a.select("cartesian").length).toBe(1);
        rerender(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef }));
        expect((_b = mbRef.current) === null || _b === void 0 ? void 0 : _b.select("cartesian").length).toBe(0);
    });
    it.each([
        { props: { visible: true, scale: [3, 2, 1] } },
        { props: { visible: false, scale: [1, 2, 3] } },
    ])("passes appropriate props to its mathbox instance", function (_a) {
        var _b;
        var props = _a.props;
        var mbRef = { current: null };
        (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
            react_1.default.createElement(components_1.Cartesian, __assign({}, props))));
        var cartesian = (_b = mbRef.current) === null || _b === void 0 ? void 0 : _b.select("cartesian");
        assertNotNil(cartesian);
        expect(cartesian.get("visible")).toBe(props.visible);
        // Mathbox converts scale to a ThreeJS Vec3
        expect(cartesian.get("scale").toArray()).toStrictEqual(props.scale);
    });
    it("updates props on its mathbox instance when rerendered", function () {
        var _a;
        var mbRef = { current: null };
        var rerender = (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
            react_1.default.createElement(components_1.Cartesian, null))).rerender;
        var cartesian = (_a = mbRef.current) === null || _a === void 0 ? void 0 : _a.select("cartesian");
        assertNotNil(cartesian);
        expect(cartesian.get("visible")).toBe(true);
        rerender(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
            react_1.default.createElement(components_1.Cartesian, { visible: false })));
        expect(cartesian.get("visible")).toBe(false);
    });
    it("updates liveProps on its mathbox instance when rerendered", function () { return __awaiter(void 0, void 0, void 0, function () {
        var mbRef, rerender, grid, w1, w2;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    mbRef = { current: null };
                    rerender = (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
                        react_1.default.createElement(components_1.Cartesian, null,
                            react_1.default.createElement(components_1.Grid, { liveProps: {
                                    width: function (t) { return 1 + t; },
                                } })))).rerender;
                    grid = (_a = mbRef.current) === null || _a === void 0 ? void 0 : _a.select("grid");
                    assertNotNil(grid);
                    w1 = grid.get("width");
                    return [4 /*yield*/, new Promise(function (resolve) {
                            setTimeout(resolve, 500);
                        })];
                case 1:
                    _b.sent();
                    w2 = grid.get("width");
                    expect(w1).toBe(1);
                    // Mathbox uses seconds
                    expect(w2 - w1).toBeGreaterThan(0.45);
                    expect(w2 - w1).toBeLessThanOrEqual(0.5);
                    rerender(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef },
                        react_1.default.createElement(components_1.Cartesian, null,
                            react_1.default.createElement(components_1.Grid, { width: 10 }))));
                    expect(grid.get("width")).toBe(10);
                    return [2 /*return*/];
            }
        });
    }); });
    it("re-renders inside new instance when root changes", function () {
        var mbRef = { current: null };
        var cartesianRef = { current: null };
        var gridRef = { current: null };
        var options1 = {};
        var rerender = (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef, options: options1 },
            react_1.default.createElement(components_1.Cartesian, { ref: cartesianRef },
                react_1.default.createElement(components_1.Grid, { ref: gridRef })))).rerender;
        var mb1 = mbRef.current;
        var cartesian1 = cartesianRef.current;
        var grid1 = gridRef.current;
        assertNotNil(mb1);
        assertNotNil(cartesian1);
        assertNotNil(grid1);
        expect(cartesian1).toHaveLength(1);
        assertSelectionsEqual(mb1.select("cartesian"), cartesian1);
        expect(grid1).toHaveLength(1);
        assertSelectionsEqual(mb1.select("grid"), grid1);
        /**
         * When re-rendered, this will create a new mathBox since the options
         * object prop will have changed.
         */
        var options2 = { plugins: ["core"] };
        expect(options1).not.toBe(options2);
        rerender(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef, options: options2 },
            react_1.default.createElement(components_1.Cartesian, { ref: cartesianRef },
                react_1.default.createElement(components_1.Grid, { ref: gridRef }))));
        var mb2 = mbRef.current;
        var cartesian2 = cartesianRef.current;
        var grid2 = gridRef.current;
        assertNotNil(mb2);
        assertNotNil(cartesian2);
        assertNotNil(grid2);
        // The options have changed (via deep equal) so a new instance is created
        expect(mb1).not.toBe(mb2);
        expect(cartesian2).toHaveLength(1);
        assertSelectionsEqual(mb2.select("cartesian"), cartesian2);
        expect(grid2).toHaveLength(1);
        assertSelectionsEqual(mb2.select("grid"), grid2);
    });
    it("Can render a new instance without error", function () { return __awaiter(void 0, void 0, void 0, function () {
        var mbRef, containerDiv, setKey, KeyedMathbox;
        return __generator(this, function (_a) {
            mbRef = { current: null };
            containerDiv = null;
            KeyedMathbox = function () {
                var _a = (0, react_1.useState)(null), container = _a[0], setContainer = _a[1];
                var _b = (0, react_1.useState)("key-0"), key = _b[0], setKeyState = _b[1];
                setKey = setKeyState;
                containerDiv = container;
                return (react_1.default.createElement("div", { ref: setContainer, key: key }, container && (react_1.default.createElement(Mathbox_1.default, { ref: mbRef, container: container },
                    react_1.default.createElement(components_1.Cartesian, null)))));
            };
            (0, react_2.render)(react_1.default.createElement(KeyedMathbox, null));
            assertNotNil(mbRef.current);
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            (0, react_2.act)(function () { return setKey("key-2"); });
            assertNotNil(containerDiv);
            expect(mbRef.current.three.element).toBe(containerDiv);
            expect(mbRef.current.select("cartesian").length).toBe(1);
            return [2 /*return*/];
        });
    }); });
    it("Can add and remove children without error", function () { return __awaiter(void 0, void 0, void 0, function () {
        var mbRef, rerender;
        return __generator(this, function (_a) {
            mbRef = { current: null };
            rerender = (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef, options: {} },
                react_1.default.createElement(components_1.Cartesian, null,
                    react_1.default.createElement(components_1.Grid, null)))).rerender;
            assertNotNil(mbRef.current);
            expect(mbRef.current.select("grid").length).toBe(1);
            rerender(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef, options: {} },
                react_1.default.createElement(components_1.Cartesian, null,
                    react_1.default.createElement(components_1.Grid, null),
                    react_1.default.createElement(components_1.Grid, null))));
            assertNotNil(mbRef.current);
            expect(mbRef.current.select("grid").length).toBe(2);
            rerender(react_1.default.createElement(ContainedMathbox_1.default, { ref: mbRef, options: {} },
                react_1.default.createElement(components_1.Cartesian, null)));
            assertNotNil(mbRef.current);
            expect(mbRef.current.select("grid").length).toBe(0);
            return [2 /*return*/];
        });
    }); });
});
describe("<Voxel />", function () {
    it("throws a runtime error if it has children", function () {
        var willThrow = function () {
            return (0, react_2.render)(react_1.default.createElement(ContainedMathbox_1.default, null,
                react_1.default.createElement(components_1.Cartesian, null,
                    react_1.default.createElement(components_1.Voxel, null,
                        react_1.default.createElement(components_1.Grid, null)))));
        };
        expect(willThrow).toThrow("Component <Voxel /> cannot have children.");
    });
});
//# sourceMappingURL=components.spec.js.map