"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LiveProps = exports.DefaultPoint = void 0;
var react_1 = __importStar(require("react"));
var utils_1 = require("./utils");
var components_1 = require("../components");
exports.default = {
    title: "Point",
    component: components_1.Point,
    argTypes: {
        color: {
            type: "string",
            defaultValue: "rgb(128, 128, 128)",
        },
        opacity: {
            type: "number",
            defaultValue: 1,
        },
        points: {
            type: "array",
            defaultValue: [[1, 1, 1]],
        },
        size: {
            type: "number",
            defaultValue: 4,
        },
    },
};
var Template = function (args) {
    var points = args.points, otherArgs = __rest(args, ["points"]);
    var _a = (0, react_1.useState)(null), data = _a[0], setData = _a[1];
    return (react_1.default.createElement(utils_1.CustomMathbox, { containerStyle: { height: 450 } },
        react_1.default.createElement(components_1.Cartesian, { range: [
                [-5, 5],
                [-5, 5],
                [-5, 5],
            ] },
            react_1.default.createElement(components_1.Grid, { axes: "xy" }),
            react_1.default.createElement(components_1.Grid, { axes: "xz" }),
            react_1.default.createElement(components_1.Array, { ref: setData, items: 1, channels: 3, data: [
                    [1, 1, 2],
                    [1, 1, 3],
                ] }),
            react_1.default.createElement(components_1.Array, { items: 1, channels: 3, data: [
                    [1, 1, -2],
                    [1, 1, -3],
                ] }),
            react_1.default.createElement(components_1.Point, __assign({ points: data }, otherArgs)))));
};
exports.DefaultPoint = Template.bind({});
exports.DefaultPoint.args = {};
exports.LiveProps = Template.bind({});
exports.LiveProps.args = {
    liveProps: {
        size: function (t) { return 20 * (1 + 0.5 * Math.sin(t)); },
    },
};
//# sourceMappingURL=Point.stories.js.map