var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useEffect, useState, forwardRef, useImperativeHandle, } from "react";
import { Color } from "three";
import { mathBox } from "mathbox";
import MathboxAPIContext from "./MathboxAPIContext";
import { useDeepCompareMemo } from "./util";
import ThreestrapContext from "../threestrap/ThreestrapContext";
var Mathbox = function (props, ref) {
    var container = props.container, children = props.children, options = props.options, rootProps = __rest(props, ["container", "children", "options"]);
    var mathboxOptions = useDeepCompareMemo(options !== null && options !== void 0 ? options : {}, {});
    var _a = useState(null), selection = _a[0], setSelection = _a[1];
    useEffect(function () {
        if (!container)
            return function () { };
        var mathbox = mathBox(__assign(__assign({}, mathboxOptions), { element: container }));
        setSelection(mathbox);
        /**
         * TODO: Should Mathbox component allow setting these more easily?
         */
        mathbox.three.renderer.setClearColor(new Color(0xffffff), 1.0);
        mathbox.three.camera.position.set(1, 1, 2);
        return function () {
            mathbox.select("*").remove();
            mathbox.three.destroy();
            setSelection(null);
        };
    }, [container, mathboxOptions]);
    useEffect(function () {
        if (!selection)
            return;
        selection.set(rootProps);
    }, [selection, rootProps]);
    useImperativeHandle(ref, function () { return selection; }, [selection]);
    return (selection && (React.createElement(MathboxAPIContext.Provider, { value: selection },
        React.createElement(ThreestrapContext.Provider, { value: selection.three }, children))));
};
export default forwardRef(Mathbox);
//# sourceMappingURL=Mathbox.js.map